<template>
  <div class="full-height flex no-wrap full-width column">
    <div class="q-headline q-px-sm">LAN Camera locator</div>
    <div
      v-if="isScanning"
      class="q-title q-px-sm q-mt-md"
    >
      Scanning: {{scanned}}/{{max}}
    </div>
    <q-table
      :columns="computedColumns"
      :data="cameras"
      :pagination.sync="pagination"
      class="q-mt-md q-mx-sm bg-white"
    >
      <q-tr
        slot="body"
        slot-scope="props"
        :props="props"
      >
        <q-td
          v-for="(column) in computedColumns"
          :key="column.name"
        >
          <span v-if="column.name !== 'url'">
            {{props.row[column.name]}}
          </span>
          <a
            v-else
            :href="props.row[column.name]"
            target="_blank"
          >
            {{props.row[column.name]}}
          </a>
        </q-td>
      </q-tr>
    </q-table>
  </div>
</template>

<script>
    import apiMixin from '../../mixins/apiMixin';
    import otherMixin from '../../mixins/otherMixin';
    import notificationMixin from '../../mixins/notificationMixin';

    export default {
      name: 'camera-locator',
      mixins: [apiMixin, otherMixin, notificationMixin],
      created() {
        this.scanCameras();
      },
      computed: {
        progress() {
          return this.scanned / 256 * 100;
        },
        computedColumns() {
          return Object.entries({
            url: 'Url',
            userId: 'User',
            locationId: 'Location',
            camId: 'Cam ID',
            segmWidth: 'Segment Width',
            segmHeight: 'Segment Height',
            segmFPS: 'Segment FPS',
            bitrate: 'Bitrate',
          }).map(([key, value]) => ({
            name: key,
            label: value,
            field: key,
            align: 'left',
            sortable: true,
          }));
        },
      },
      data() {
        return {
          isScanning: false,
          scanned: 0,
          max: 256,

          cameras: [],

          pagination: {
            rowsPerPage: 256,
          },
        };
      },
      methods: {
        async scanCameras() {
          this.isScanning = true;

          const ips = await this.getLocalIp();

          const ip = ips[0];
          const ipParts = ip.split('.');
          ipParts.pop();
          const ipPart = `${ ipParts.join('.') }.`;

          Promise.all(
            // eslint-disable-next-line
            Array(this.max).fill(null).map((i, index) => new Promise((resolve, reject) => {
              const cameraAddress = `http://${ ipPart }${ index }:5000/getCamInfo`;

              this.apiGet([cameraAddress], {
                timeout: 5000,
              })
                .then(({
                   results,
                }) => {
                  this.scanned += 1;
                  if (results) {
                    results.forEach(({
                      user_id: userId,
                      location_id: locationId,
                      cam_id: camId,
                      segm_width: segmWidth,
                      segm_height: segmHeight,
                      segm_fps: segmFPS,
                      bitrate,
                    }) => {
                      this.cameras.push({
                        url: `http://${ ipPart }${ index }/`,
                        userId,
                        locationId,
                        camId,
                        segmWidth,
                        segmHeight,
                        segmFPS,
                        bitrate,
                      });
                    });
                  }
                  resolve();
                })
                .catch(() => {
                  this.scanned += 1;
                  resolve();
                });
            })),
          )
            .then(() => {
              this.isScanning = false;
              this.scanned = 0;

              this.notifyInfo({
                title: 'Cameras scanned',
              });
            })
            .catch(() => {
              this.isScanning = false;
              this.scanned = 0;

              this.notifyError({
                message: 'Unable to scan cameras',
              });
            });
        },
      },
    };
</script>
